package ru.dbotthepony.mc.otm.network;

import net.minecraft.network.FriendlyByteBuf;
import net.minecraftforge.network.NetworkEvent;
import ru.dbotthepony.mc.otm.capability.matter.MatterTask;
import ru.dbotthepony.mc.otm.menu.MatterPanelMenu;

import java.util.UUID;
import java.util.function.Supplier;

public record CancelMatterTaskPacket(UUID id) {
	public CancelMatterTaskPacket(UUID id) {
		this.id = id;
	}

	public CancelMatterTaskPacket(MatterTask task) {
		this(task.id());
	}

	public void write(FriendlyByteBuf buffer) {
		buffer.writeLong(id.getMostSignificantBits());
		buffer.writeLong(id.getLeastSignificantBits());
	}

	public void play(Supplier<NetworkEvent.Context> context) {
		context.get().setPacketHandled(true);

		context.get().enqueueWork(() -> {
			var player = context.get().getSender();

			if (player.containerMenu instanceof MatterPanelMenu menu) {
				menu.receiveTaskCancel(player, id);
			}
		});
	}

	public static CancelMatterTaskPacket read(FriendlyByteBuf buffer) {
		return new CancelMatterTaskPacket(new UUID(buffer.readLong(), buffer.readLong()));
	}
}
